//am29200v.h
//memory mapped registers for the AMD AM29200 processor
//as variables, values are defined in assembler-file "am29200.h"
//19930602/wjvg

extern io long rmct;  //ROM control register
extern io long rmcf;  //ROM configuration register
extern io long drct;  //DRAM control register
extern io long drcf;  //DRAM configuration register

extern io long drm0;  //DRAM mapping register 0
extern io long drm1;  //DRAM mapping register 1
extern io long drm2;  //DRAM mapping register 2
extern io long drm3;  //DRAM mapping register 3

extern io long pict0;  //PIA control register 0
extern io long pict1;  //PIA control register 1
extern io long ict;    //interrupt control register

extern io long dmct0;  //DMA0 control register
extern io long dmad0;  //DMA0 address register
extern io long tad0;   //DMA0 address tail register
extern io long dmcn0;  //DMA0 count register
extern io long tcn0;   //DMA0 count tail register

extern io long dmct1;  //DMA1 control register
extern io long dmad1;  //DMA1 address register
extern io long tad1;   //DMA1 address tail register
extern io long dmcn1;  //DMA1 count register
extern io long tcn1;   //DMA1 count tail register

extern io long spct;  //serial port control register
extern io long spst;  //serial port status register
extern io long spth;  //serial port transmit holding register
extern io long sprb;  //serial port receive buffer register
extern io long baud;  //baud rate divisor register

extern io long ppct;  //parallel port control register
extern io long ppst;  //parallel port status register
extern io long ppdt;  //parallel port data register

extern io long poct;  //PIO control register
extern io long pin ;  //PIO input register
extern io long pout;  //PIO output register
extern io long poen;  //PIO output enable register

extern io long vct ;  //video control register
extern io long top ;  //video margin register
extern io long side;  //side margin register
extern io long vdt ;  //video data holding register

//end
