#!/usr/bin/perl
#adjust the permissions of the given files
#20000812/wjvg

sub do_current_dir {
  my @dir;
  my $file;

  if (opendir DIR,'.') {                      #open current dir
    if (@dir=readdir DIR) {                   #read the directory
      foreach $file (@dir) {
        if ($file ne "." && $file ne "..") {  #not these directories?
          do_file($file);                     #do the file
        }
      }
    }
    else {
      die "can't read directory: '.'";
    }
  }
  else {
    die "can't open directory: '.'";
  }
}

sub do_file($) {
  printf "doing file: '%s'\n",$_[0];
  if (-d $_[0]) {                     #directory?
    chmod 0755,$_[0];                 #enable entry, perm -> drwxr-xr-x
    if ($_[0] eq ".") {               #the current directory?
      do_current_dir();               #do it
    }
    elsif (chdir $_[0]) {             #go in
      do_current_dir();               #do it
      chdir '..';                     #go level up again
    }
    else {
      die "can't enter directory: '".$_[0]."'";
    }
  }
  elsif (-e $_[0]) {                  #does the file exist?
    if ($_[0] =~ /.*\.php/) {         #php file?
      chmod 0755,$_[0];               #change permission of file to -rwxr-xr-x
    }
    elsif ($_[0] =~ /.*\.pl/) {       #perl file?
      chmod 0755,$_[0];               #change permission of file to -rwxr-xr-x
    }
    else {
      chmod 0644,$_[0];               #change permission of file to -rw-r--r--
    }
  }
  else {
    warn "unknown file: '".$_[0]."'";
  }
}

foreach $file (@ARGV) {
  do_file($file);
}

